#!/usr/bin/env perl
# Array::Gap is available at http://github.com/naoya/perl-array-gap/tree/master
use strict;
use warnings;
use FindBin::libs;
use Perl6::Say;
use Devel::Size qw/size/;

use Array::Gap;

my $a = Array::Gap->new;
$a->push(824);
$a->push(829);
$a->push(830);
$a->push(851);
$a->push(1024);
$a->push(215406);

my $iter = $a->iterator;
while ($iter->has_next) {
    say $iter->next;
}

say sprintf "size of compressed gapped array: %d bytes", size($a->bin);
say sprintf "size of normal array: %d bytes", size([824, 829, 830, 851, 1024, 215406]);
