#!/usr/bin/env perl
use strict;
use warnings;
use integer;

sub vb_encode {
    my $n = shift;

    my @bytes;
    while (1) {
        unshift @bytes, $n % 128;
        if ($n < 128) {
            last;
        }
        $n = $n / 128;
    }
    $bytes[-1] += 128;

    return pack('C*', @bytes);
}

sub vb_decode {
    my $vb = shift;

    my $n   = 0;
    for my $c (unpack('C*', $vb)) {
        if ($c < 128) {
            $n = 128 * $n + $c;
        } else {
            return 128 * $n + ($c - 128);
        }
    }
}

use Test::More qw/no_plan/;

is vb_decode(vb_encode(0)), 0;
is vb_decode(vb_encode(1)), 1;
is vb_decode(vb_encode(5)), 5;
is vb_decode(vb_encode(127)), 127;
is vb_decode(vb_encode(128)), 128;
is vb_decode(vb_encode(256)), 256;
is vb_decode(vb_encode(256)), 256;
is vb_decode(vb_encode(16384)), 16384;

is length vb_encode(0), 1;
is length vb_encode(5), 1;
is length vb_encode(127), 1;
is length vb_encode(128), 2;
is length vb_encode(16384), 3;

# use Perl6::Say;

# say unpack('B*', vb_encode(20001));
# say unpack('B*', vb_encode(130));
# say unpack('B*', vb_encode(5));
# say unpack('B*', pack('w', 130));

# vb_decode(vb_encode(130))
